import es, time, usermsg, cfglib

dm = es.import_addon('dm')
delay = dm.delay


class Settings(object):
    config = cfglib.AddonCFG(dm.addondir + '/dm/addons/respawntypes/time/settings.cfg')
    _respawntime   = config.cvar('dm_time_respawntime', 3.0, 'Respawn interval [Time after death]'), float
    
    config.execute()
    
    def __init__(self):
        self.config.write()
        
    def __getattr__(self, name):
        if hasattr(Settings, name):
            return super(Settings, self).__getattribute__(name)
           
        elif hasattr(Settings, '_'+name):
            val, func = super(Settings, self).__getattribute__('_'+name)
            return func(val)
           
        raise AttributeError, 'No such attribute "%s"'%name
        
settings = Settings()

def player_death(ev):
    delay.delayed(settings.respawntime, 'dm_respawn_time_%s'%ev['userid'], dm.timedSpawn, (ev['userid'],))

def player_team(ev):
    delay.cancel('dm_respawn_time_%s'%ev['userid'])
    
    if int(ev['team']) in (2,3):
        delay.delayed(settings.respawntime, 'dm_respawn_time_%s'%ev['userid'], dm.timedSpawn, (ev['userid'],))
    
    
def round_start(ev):
    delay.cancelPrefix('dm_respawn_time_')
    
def unload():
    delay.cancelPrefix('dm_respawn_time_')